c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine init()
      implicit none
      integer outk,sma
      character*100 dest,fichier,email
c     Purpose: perform various initialisation tasks
      include 'max.inc'
      include 'data.inc'
      include 'email.inc'


c      call write_pid() ! criture du PID de Karine dans le fichier './pid'

      call detect_first_use()

      author_email='eymet@energetique.ups-tlse.fr'
      call read_config(sma)

      call erase_results()
      
      call detect_kernel(outk)
      if (outk.eq.0) then ! default: kernel > 2.4
         call detect_viewer(outv) ! dtection du programme de visualisation graphique
         call detect_javac(javac) ! dtection de javac
c     Debug
c      write(*,*) 'javac=',javac
c      if (javac.eq.1) then
c         write(*,*) 'javac a t dtect'
c      else
c         write(*,*) 'javac n''a pas t dtect'
c      endif
c     Debug
         if (javac.eq.1) then   ! si java est install
c     compilation de l'applet java "overwrite_progress_line.java"
            call system('javac ./bash/overwrite_progress_line.java')
c     compilation de l'applet java "overwrite_init_line.java"
            call system('javac ./bash/overwrite_init_line.java')
c     Debug
c         write(*,*) 'bash/overwrite_line a t compil'
c      else
c         write(*,*) 'bash/overwrite_line n''a pas t compil'
c     Debug
         endif

c     Prparation du texte du mail de lancement de simul
         fichier='mail.txt'
         call make_start_mail(sma,fichier)
c     Debug
c            stop
c     Debug

c     Expdition
         dest=author_email
         call send_mail(sma,dest,fichier)

c     Effacement des fichiers temporaires
         call  erase_temporary()

      else ! if a 2.4 kernel is used
         outv=0
         javac=0
      endif
c     Debug
c      stop
c     Debug

      return
      end
