c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine init_results(Nb,Nq)
      implicit none
c     Cette routine initialise tous les tableaux de rsultats
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'tab.inc'
      include 'formats.inc'
      integer i,j,q,sec,nk,strlen
      integer Nb,Nq,band,quad,num,md0,paq0
      character*100 name,arrays1
      
      nk=Kmax
      arrays1='./temporary/arrays1.sav'
      call cur_date(date1)
      call angular_discretization()

      if (raz.eq.1) then ! si on reprend le calcul avant interruption
         open(10,file='./temporary/sauvegarde.txt')
         read(10,*) name
         close(10)
c     'name' contient le nom du fichier ('arrays1.sav' ou 'arrays2.sav')
c     dans lequel l'tat du calcul a t sauvegard en entier avec succs
c     pour la dernire fois.

c     On reprend donc ce dernier bon tat

         open(11,file=name(1:strlen(name)))
         read(11,*) md_min,paq_min
         read(11,*) date0
         call screen(20,0,0,0.0D+0,0.0D+0)
         do i=0,m+1
            do j=0,m+1
               read(11,*) sum_pneh(i,j)
               read(11,*) sum2_pneh(i,j)
               read(11,*) sum_pneb(i,j)
               read(11,*) sum2_pneb(i,j)
               read(11,*) sum_fasch(i,j)
               read(11,*) sum2_fasch(i,j)
               read(11,*) sum_fdesh(i,j)
               read(11,*) sum2_fdesh(i,j)
               read(11,*) sum_fascb(i,j)
               read(11,*) sum2_fascb(i,j)
               read(11,*) sum_fdesb(i,j)
               read(11,*) sum2_fdesb(i,j)
            enddo
         enddo
         do i=0,m
            do sec=1,Nsec
               read(11,*) sum_fah_ang(i,sec)
               read(11,*) sum2_fah_ang(i,sec)
               read(11,*) sum_fdh_ang(i,sec)
               read(11,*) sum2_fdh_ang(i,sec)
               read(11,*) sum_fab_ang(i,sec)
               read(11,*) sum2_fab_ang(i,sec)
               read(11,*) sum_fdb_ang(i,sec)
               read(11,*) sum2_fdb_ang(i,sec)
            enddo
         enddo
         do q=1,Nb*Nq
            do i=0,m+1
               read(11,*) sum_bilh(i,q)
               read(11,*) sum2_bilh(i,q)
               read(11,*) sum_bilb(i,q)
               read(11,*) sum2_bilb(i,q)
               read(11,*) sum_bil_rev_h(i,q)
               read(11,*) sum2_bil_rev_h(i,q)
               read(11,*) sum_bil_rev_b(i,q)
               read(11,*) sum2_bil_rev_b(i,q)
               read(11,*) sum_bil_gs_h(i,q)
               read(11,*) sum_bil_ge_h(i,q)
               read(11,*) sum_bil_gg_h(i,q)
               read(11,*) sum2_bil_gs_h(i,q)
               read(11,*) sum2_bil_ge_h(i,q)
               read(11,*) sum2_bil_gg_h(i,q)
               read(11,*) sum_bil_gs_b(i,q)
               read(11,*) sum_bil_ge_b(i,q)
               read(11,*) sum_bil_gg_b(i,q)
               read(11,*) sum2_bil_gs_b(i,q)
               read(11,*) sum2_bil_ge_b(i,q)
               read(11,*) sum2_bil_gg_b(i,q)
            enddo
            do j=0,m
               read(11,*) sum_fafh(j,q)
               read(11,*) sum_fdfh(j,q)
               read(11,*) sum_fafb(j,q)
               read(11,*) sum_fdfb(j,q)
               read(11,*) sum2_fafh(j,q)
               read(11,*) sum2_fdfh(j,q)
               read(11,*) sum2_fafb(j,q)
               read(11,*) sum2_fdfb(j,q)
            enddo
         enddo
         close(11)
         nray1=0.0D+0
         if (md_min.gt.0) then
            do i=0,md_min-1
               call calc_nmax(i,num)
               nray1=nray1+dble(num)
            enddo
         endif
         nray1=nray1+dble(paq_min-1) ! nombre de calculs termins  la reprise
c     md0 et paq0 reprent l'tat du calcul au moment de la dernire
c     sauvegarde
         if ((paq_min.eq.1).and.(md_min.gt.0)) then
            md0=md_min-1
            call calc_nmax(md0,paq0)
         else
            md0=md_min
            paq0=paq_min-1
         endif
         call print_state(Nb,Nq,0,0,md0,paq0)
         md_prec=md0
         paq_prec=paq0
      else ! sinon on reprend un nouveau calcul
         md_min=0
         paq_min=1
         do i=0,m+1
            do j=0,m+1
               sum_pneh(i,j)=0.0D+0
               sum2_pneh(i,j)=0.0D+0
               sum_pneb(i,j)=0.0D+0
               sum2_pneb(i,j)=0.0D+0
c     On n'initialise mme pas les tableaux temporaires pour
c     calcul des PNE monochromatiques si on a choisi de ne
c     pas les calculer, sinon a utilise beaucoup plus
c     de RAM
               if (cpm.eq.1) then
                  do q=1,nk
c                     call signal_handler() ! signal handling
                     sum_pnefh(i,j,q)=0.0D+0
                     sum_pnefb(i,j,q)=0.0D+0
                     sum2_pnefh(i,j,q)=0.0D+0
                     sum2_pnefb(i,j,q)=0.0D+0
                  enddo         ! sur k
               endif
c
c
            enddo ! sur j
         enddo ! sur i

         do i=0,m+1
            do j=0,m+1
               sum_fasch(i,j)=0.0D+0
               sum_fascb(i,j)=0.0D+0
               sum_fdesh(i,j)=0.0D+0
               sum_fdesb(i,j)=0.0D+0
               sum2_fasch(i,j)=0.0D+0
               sum2_fascb(i,j)=0.0D+0
               sum2_fdesh(i,j)=0.0D+0
               sum2_fdesb(i,j)=0.0D+0
            enddo ! j
         enddo ! i

         if (cpm.eq.1) then
            do j=0,m
               do q=1,nk
                  sum_fafh(j,q)=0.0D+0
                  sum_fdfh(j,q)=0.0D+0
                  sum_fafb(j,q)=0.0D+0
                  sum_fdfb(j,q)=0.0D+0
                  sum2_fafh(j,q)=0.0D+0
                  sum2_fdfh(j,q)=0.0D+0
                  sum2_fafb(j,q)=0.0D+0
                  sum2_fdfb(j,q)=0.0D+0
               enddo            ! q
            enddo               ! j
         endif

         do i=0,Nmax
            do sec=1,Nsec_mx
               sum_fah_ang(i,sec)=0.0D+0
               sum_fab_ang(i,sec)=0.0D+0
               sum_fdh_ang(i,sec)=0.0D+0
               sum_fdb_ang(i,sec)=0.0D+0
               sum2_fah_ang(i,sec)=0.0D+0
               sum2_fab_ang(i,sec)=0.0D+0
               sum2_fdh_ang(i,sec)=0.0D+0
               sum2_fdb_ang(i,sec)=0.0D+0
            enddo               ! sec
         enddo                  ! i

         do q=1,nk
            do i=0,m+1
c               call signal_handler() ! signal handling
               sum_bilh(i,q)=0.0D+0
               sum2_bilh(i,q)=0.0D+0
               sum_bilb(i,q)=0.0D+0
               sum2_bilb(i,q)=0.0D+0
               sum_bil_rev_h(i,q)=0.0D+0
               sum2_bil_rev_h(i,q)=0.0D+0
               sum_bil_rev_b(i,q)=0.0D+0
               sum2_bil_rev_b(i,q)=0.0D+0
               sum_bil_gs_h(i,q)=0.0D+0
               sum_bil_ge_h(i,q)=0.0D+0
               sum_bil_gg_h(i,q)=0.0D+0
               sum2_bil_gs_h(i,q)=0.0D+0
               sum2_bil_ge_h(i,q)=0.0D+0
               sum2_bil_gg_h(i,q)=0.0D+0
               sum_bil_gs_b(i,q)=0.0D+0
               sum_bil_ge_b(i,q)=0.0D+0
               sum_bil_gg_b(i,q)=0.0D+0
               sum2_bil_gs_b(i,q)=0.0D+0
               sum2_bil_ge_b(i,q)=0.0D+0
               sum2_bil_gg_b(i,q)=0.0D+0
            enddo ! i
         enddo ! q
         open(10,file='./temporary/sauvegarde.txt')
         write(10,53) '"'//arrays1(1:strlen(arrays1))//'"'
         close(10)
c         open(11,file='time')
c         write(11,*) 0
c         close(11)
         call print_state(Nb,Nq,0,0,0,0)
         nray1=0.0D+0
         md_prec=0
         paq_prec=0
      endif
      
      call cur_date(date_start)

 1234 continue
      return
      end
      
